from Components.config import config, ConfigSet, ConfigSubsection, ConfigYesNo
from Screens.ChannelSelection import ChannelSelection
from enigma import eServiceReference

# Plugin definition
from Plugins.Plugin import PluginDescriptor

config.plugins.classiczaphistory = ConfigSubsection()
config.plugins.classiczaphistory.enabled = ConfigYesNo(default = True)
config.plugins.classiczaphistory.history_tv = ConfigSet(choices = [])
config.plugins.classiczaphistory.history_radio = ConfigSet(choices = [])

# new addToHistory
baseAddToHistory = None
def addToHistory(self, ref):
	if self.servicePath is not None:
		tmp=self.servicePath[:]
		tmp.append(ref)
		try:
			del self.history[self.history_pos+1:]
		except Exception, e:
			pass
		if tmp in self.history:
			self.history.remove(tmp)

	if baseAddToHistory: baseAddToHistory(self, ref)
	if self.history == self.history_tv:
		config.plugins.classiczaphistory.history_tv.value = [[y.toString() for y in x] for x in self.history]
	else:
		config.plugins.classiczaphistory.history_radio.value = [[y.toString() for y in x] for x in self.history]
	config.plugins.classiczaphistory.save()

# new __init__
baseInit = None
def newInit(self, session):
	if baseInit: baseInit(self, session)
	append = self.history_tv.append
	for x in config.plugins.classiczaphistory.history_tv.value:
		append([eServiceReference(y) for y in x])
	append = self.history_radio.append
	for x in config.plugins.classiczaphistory.history_radio.value:
		append([eServiceReference(y) for y in x])

	# XXX: self.lastChannelRootTimer was always finished for me, so just fix its mistakes ;)
	if self.history == self.history_tv:
		self.history_pos = len(self.history_tv)-1
	else:
		self.history_pos = len(self.history_radio)-1

if config.plugins.classiczaphistory.enabled.value:
	baseAddToHistory = ChannelSelection.addToHistory
	baseInit = ChannelSelection.__init__
	ChannelSelection.addToHistory = addToHistory
	ChannelSelection.__init__ = newInit

def Plugins(**kwargs):
	return [
	]
